'Impulsformung von 8 Schalter-Eingngen
'Siehe http://www.mikrocontroller.net/topic/214865#2138197

'Pinbelegung ATTiny2313:
'Eingnge an PortD
'Ausgnge an PortB


$regfile = "attiny2313.dat"             'Portnamen vereinbaren
$crystal = 1000000                      'Takt vereinbaren
$hwstack = 32                           'Reg-Sicherung, Rcksprungadressen
$swstack = 10                           'Parameterbergabe
$framesize = 10                         'Rechenbereich Funktionen

Const Dauer = 10                        'Impulsdauer in 16,384 ms


Dim Tz0 As Byte                         'Prellzhler Bit 0
Dim Tz1 As Byte                         'Prellzhler Bit 1
Dim Tas As Byte                         'Tastenstatus
Dim Tfl As Byte                         'Flags neu bettigter Tasten
Dim Ida(8)as Byte                       'Impulsdauer der Ausgangsimpulse
Dim I As Byte                           'temporr
Dim Mas As Byte                         'Maske auf Tastenbit
Dim Tmp As Byte                         'temporr
Dim Tes As Byte                         'Test

Tccr0b = 3                              'Timer0-berlauf alle 16,384 ms
Timsk = Bits(toie0)                     'Timer0-berlauf-Int freigeben
Enable Interrupts                       'Interrupts freigeben

On Ovf0 Isr_timer0ovf                   'Nosave          'berlauf-Interrupt

Ddrb = 255                              'alle Pins des PortB als Ausgang
Portd = 255                             'alle PullUp-Widerstnde PortD ein
Porta = 3                               'PullUp-Widerstnde PortA ein


Do
Loop


Isr_timer0ovf:                          'Interrupt-Handler berlauf Timer 0
    I = Pind                            'Eingnge einlesen
    I.7 = Pina.0                        'PA0 dazuschummeln (statt PD7)
    'Der Entprell-Algorithmus ist bei Peter-Dannegger abgeguckt:
    I = Not I                           'Pegel invertieren
    I = I Xor Tas                       'nur nderungen erhalten
    Tz0 = Tz0 And I                     'Prellzhler (Bit 0) unvernderter
    Tz1 = Tz1 And I                     'Tasten lschen (Bit 1)
    Tz0 = Not Tz0                       'L-Bits des Prellzhlers zhlen
    Tz1 = Tz1 Xor Tz0                   'H-Bits des Prellzhlers zhlen
    I = I And Tz0                       'nderungen nur bei Zhlerstand 3
    I = I And Tz1                       'erhalten
    Tas = Tas Xor I                     'Zustnde vernderter Tasten kippen
    I = I And Tas                       'nur neu gedrckte Tasten beachten
    Tfl = Tfl Or I                      'Flags der neu gedrckten Tasten setzen
'In Tfl sind jetzt die Bits gesetzt, deren Tasten seit dem letzten Lschen
'losgelassen und wieder gedrckt wurden.


'Ausgnge neu erkannter Tastendrcke einschalten:
    Mas = 1                             'Bit 0 in der Tastenbitmaske setzen
    For I = 1 To 8                      'alle 8 Timer
      Tmp = Tfl And Mas                 'wenn Taste neu
      If Tmp <> 0 Then                  'gedrckt wurde
        Ida(i) = Dauer                  'Impulsdauer auf Startwert setzen
        Portb = Portb Or Mas            'Ausgangs-Bit setzen
      End If
'Tastendruck entwerten:
      Tmp = Not Mas                     'Kopie der umgekehrten Bitmaske
      Tfl = Tfl And Tmp                 'aktuelles Tastenflag lschen
'Ausgnge nach Ablauf der Impulsdauer ausschalten:
      If Ida(i) <> 0 Then               'wenn der Impulstimer luft
        Decr Ida(i)                     'herunterzhlen
        If Ida(i) = 0 Then              'bei Ablauf
          Portb = Portb And Tmp         'Ausgangs-Bit lschen
        End If
      End If
      Shift Mas , Left                  'Maske auf nchstes Bit setzen
    Next I                              'nchsten Timer behandeln
    Tfl = 0                             'alle bearbeiteten Tastenbits lschen
  Return                                'fertig, zurck