'Terminal fr Andreas Dittrichs Akkulader

$regfile = "m8def.dat"
Const Quarz = 4000000                   'CPU-Takt
$crystal = Quarz                        'Quarzfrequenz
$baud = 19200                           'Baudrate UART

Const Ifa = 667                         'Skalier-Faktor Ist-Strom
Const Isofa = 130                       'Skalier-Faktor Soll-Strom
Const Ufa = 20                          'Skalier-Faktor Spannung
Const Bifa = 1011                       'Korrektur-Faktor Big-Volt
'Const Akkus = 11                        'Anzahl der Ladeschchte
Const Ausmskd = &B11000001              'AND-Maske zum Rel. Ausschalten Port D
Const Ausmskb = &B11000000              'AND-Maske zum Rel. Ausschalten Port B

Bitmuster:
Data 2 , 0 , 4 , 0 , 8 , 0 , 16 , 0 , 32 , 0       'Relais an PortD
Data 0 , 1 , 0 , 2 , 0 , 4 , 0 , 8 , 0 , 16 , 0 , 32       'Relais an PortB

Config Lcd = 16 * 2
Config Lcdpin = Pin , E = Portd.7 , Rs = Portd.6 , Db4 = Portc.0 , Db5 = Portc.1 , Db6 = Portc.2 , Db7 = Portc.3

Declare Sub Neutelegramm                'neues Telegramm auswerten


'Const Ampfakt = 667                     'Faktor fr Stromskalierung

'$sim
Dim Rx_buf(10)as Byte                   'Empfangsbuffer
Dim Rix As Byte                         'RX-Index
Dim W1 As Word                          'Wert 1
Dim W2 As Word                          'Wert 2
Dim W3 As Word                          'Wert 3
Dim Lmo As Byte                         'Lade-Modus
  Laden Alias Lmo.7                     'Statusbit Laden
  Langsam Alias Lmo.6                   'Statusbit langsam laden
  Ubig Alias Lmo.5                      'Statusbit Spannungsteiler

Dim Ix As Byte                          'Index auf Array
Dim Cks As Word                         'Checksumme
Dim Merker As Byte                      'einige Merker
  Fehler Alias Merker.0                 'Merker "Fehler"
  Neuwert Alias Merker.1                'Merker "neuer Wert"
Dim Umil As Word                        'Ladespannung (in mV)
Dim Imil As Word                        'Ladestrom (in mA)
Dim Isol As Word                        'eingestellter Sollstrom
Dim Ladesek As Word                     'bisherige Ladezeit (in Sekunden)
Dim Masek As Long                       'bereits geladene mAs
Dim Mastu As Word                       'geladene Kapazitt (in mAh)
Dim Tmp32 As Long                       'temporr zum 32-Bit-Rechnen
Dim Tmp As Byte                         'temporr

On Urxc Onrxd
Enable Urxc
Enable Interrupts



Config Lcd = Lcdtyp                     'LCD-Gre
Config Lcdpin = Lcdpins                 'LCD-Anschlsse


Initlcd
'initialisieren
Cls


Do                                      'Hauprschleife
 If Rix > 9 Then Neutelegramm           'neues Telegramm eingetroffen
Loop

Onrxd:
  Incr Rix                              'Schreibposition im Array erhhen
  Rx_buf(rix) = Udr                     'Empfangsbyte in Buffer legen
Return


Sub Neutelegramm                        'Neues Telegramm eingetroffen
  If Rx_buf(1) = &HED Then              'Stimmt das Startbyte?
    If Rx_buf(10) = &H4D Then           'Stimmt auch das Stop-Byte?
      Cks = 0                           'Checksumme Auf 0
      For Ix = 2 To 8                   'alle Datenbytes
        Cks = Cks + Rx_buf(ix)          'addieren
      Next Ix
      Ix = Cks And 255                  'nur unteres Byte
      If Rx_buf(9) = Ix Then            'Stimmt die Prfsumme?
        W1 = Rx_buf(3) * 256            'Wert 1
        W1 = W1 + Rx_buf(2)             'kopieren
        W2 = Rx_buf(5) * 256            'Wert 2
        W2 = W2 + Rx_buf(4)             'kopieren
        W3 = Rx_buf(7) * 256            'Wert 3
        W3 = W3 + Rx_buf(6)             'kopieren
        Lmo = Rx_buf(8)                 'Lademodus kopieren
        For Ix = 1 To 10                'Array
          Rx_buf(ix) = 0                'lschen
        Next Ix
        Rix = 0                         'von vorn einlesen
        Set Neuwert                     'neuen Wert melden
      Else                              'Prfsumme stimmt nicht
        Set Fehler                      'Fehler melden
      End If
    Else                                'Stop-Byte stimmt nicht
      Set Fehler                        'Fehler melden
    End If
  Else                                  'Startbyte stimmt nicht
    Set Fehler                          'Fehler melden
  End If                                'Startbyte

  If Fehler = 1 Then                    'bei Sync-Fehler
    For Ix = 1 To 9                     'alle Bytes
      Rx_buf(ix) = Rx_buf(ix + 1)       'um eine Position
    Next Ix                             'verschieben
    Decr Rix                            'letztes Byte nochmal einlesen lassen
    Reset Fehler                        'Fehlerflag lschen
    Exit Sub                            'auf Anzeige verzichten...
  End If

  If Neuwert = 1 Then                   'wenn neue Werte da sind
    Reset Neuwert                       'Merker entwerten
'Wert1 enthlt in beiden Telegrammtypen immer die Spannung am Akku.
'Ob sie als "small" oder "big" angezeit werden muss, muss anderweitig
'ermittelt werden (Pegel an Pin 13 des Tiny26?).
'Beim Laden nur einer Zelle ist sie "small".
'Ladespannung "small" bestimmen, (R2 offen, Spannungsteiler R10/R2 unwirksam)
    Tmp32 = W1                          'Wert1
    Tmp32 = Tmp32 * Ufa                 'auf Millivolt
    Tmp32 = Tmp32 / 256                 'skalieren
    Umil = Tmp32                        'und bernehmen
    If Ubig = 1 Then                    'Spannungsteiler aktiv?
      'ja, Ladespannung "big" (R2 auf GND, Spannungsteiler R10/R2 wirksam)
      Tmp32 = Tmp32 * Bifa              'Spannungsteilerfaktor
      Tmp32 = Tmp32 / 256               'einrechnen
      Umil = Tmp32                      'umil enthlt jetzt die Akkuspannung
    End If
    'Ladezeit ist in W2
    Ladesek = W2                        'Ladezeit in Sekunden
    'Ladestrom (Iststrom) ist in W3
    Tmp32 = W3
    Tmp32 = Tmp32 * Ifa                 'Ladestrom
    Tmp32 = Tmp32 / 256                 'skalieren
    Imil = Tmp32                        'und bernehmen
    'Whrend des Ladens enthlt W3 den Wert einer Strom-Messung
    'im Ruhezustand enthlt W3 aber 32 aufsummierte Strom-Messungen!!
    Tmp = Lmo And &HC0                  'Ladebits isolieren
    If Tmp = 0 Then                     'ist Ruhemodus aktiv?
      Imil = Imil / 32                  'ja, dann durch 32 teilen
      Masek = 0                         'Milliamp-Sekunden lschen
    End If                              'imil enthlt den Iststrom
    'Sollstrom (Ladestufe) ist in den unteren 4 Bit von Lmo
    Isol = Lmo And 15                   'Ladestufe isolieren
    Isol = Isol * Isofa                 'Ladestrom Schnelladen
    If Langsam = 1 Then                 'langsames Laden aktiv?
      Isol = Isol / 10                  'Anzeigewert dezimieren
    End If
    'Bereits geladene Kapazitt ermitteln
    If Laden = 1 Then                   'wird der Akku geladen?
      Masek = Masek + Imil              'ja, Milliamperesekunden summieren
      Mastu = Masek / 3600              'durch s/h, um mAh zu bekommen
    End If                              'in Mastu ist die geladene Kapazitt
  End If
  'Zur Ausgabe stehen jetzt folgende Variablen bereit:
  'Umil         (word) Ladespannung in Millivolt
  'Imil         (word) Istwert Ladestrom in Milliampere
  'Isol         (word) Sollwert Ladestrom laut Stromstufe in Milliampere
  'Ladesek      (word) bereits vergangene Ladezeit in Sekunden
  'Mastu        (word) bereits geladene Kapazitt in Milliamperestunden

  'Hier LCD-Ausgabe einbauen... ;-)
  Cls
  'der folgende Code dient nur als Beispiel...
  Select Case Tmp                       'je nach Betriebsart
    Case &H00                           'Bereitschaft
      Locate 1 , 1
        Lcd "t=" ; Ladesek              'verstrichene Sekunden
      Locate 1 , 9
        Lcd "U=" ; Umil                 'Spannung in Millivolt
      Locate 2 , 1
        Lcd "Is=" ; Isol                'Soll-Ladestrom laut Stromfaktor
      Locate 2 , 9
        Lcd "Kap=" ; Mastu              'Kapazitt in Milliamperestunden

    Case &H80                           'Schnelladen
      Locate 1 , 1
        Lcd "Ii=" ; Imil                'Ist-Ladestrom in Milliampere
      Locate 1 , 9
        Lcd "U=" ; Umil                 'Spannung in Millivolt
      Locate 2 , 1
        Lcd "Is=" ; Isol                'Sollwert Ladestrom
      Locate 2 , 9
        Lcd "C=" ; Mastu                'Kapazitt in Milliamperestunden

    Case &HC0                           'langsam laden
      Locate 1 , 1
        Lcd "Ii=" ; Imil                'Ist-Ladestrom in Milliampere
      Locate 1 , 9
        Lcd "U=" ; Umil                 'Spannung in Millivolt
      Locate 2 , 1
        Lcd "Is=" ; Isol                'Sollwert Ladestrom
      Locate 2 , 9
        Lcd "C=" ; Mastu                'Kapazitt in Milliamperestunden

  End Select

End Sub                                 'fertig, zurck...