'Rundumleuchte mit 8 LEDs und Tiny13

'Pinbelegung ATTiny13:

'            Reset   Pin 1   Pin 8   Vcc
'     LED 7, LED 8   Pin 2   Pin 7   LED 5, LED 6
'   LED-Common (R)   Pin 3   Pin 6   LED 3, LED 4
'              GND   Pin 4   Pin 5   LED 1, LED 2

Const Tempo = 2000                      'Dreh-Tempo (500 bis 65535)
Const Schritte = 20                     'Anzahl der Dimm-Schritte
Const Richtung = 0                      'Drehrichtung (0=vorwrts, 1=rckwrts)

'Bascom-spezifische Deklarationen:
$regfile = "attiny13.dat"               'Portnamen vereinbaren
$crystal = 9600000                      'Takt vereinbaren
$hwstack = 32                           'Rcksprungadressen und Registersicherung
$swstack = 2                            'Parameterbergabe
$framesize = 2                          'Arbeitsbereich fr Funktionen

Dim Leuchtzeit(8)as Byte                'Leuchtdauer jeder LED
Dim Ddr_bimu(8)as Byte                  'Bitmuster fr Datenrichtungsregister
Dim Port_bimu(8)as Byte                 'Bitmuster fr Portregister
Dim I As Byte                           'Index auf LED im Hauptprogramm
Dim N As Byte                           'Index auf LED in ISR
Dim R As Byte                           'Richtung

On Oc0a Isr_oc0a

Clkpr = Bits(clkpce)                    'Schreibschutz fr Taktvorteiler aufheben
Clkpr = 0                               'System-Taktvorteiler 1 zu 1
Clkpr = 0                               'sollte zweimal geschrieben werden

R = Richtung

Restore Bitmuster                       'Zeiger auf Datenbereich im Flash
For I = 1 To 8                          'Bitmuster fr 8 LEDs
  Read Ddr_bimu(i)                      'Datenrichtungs-Bitmuster holen
  Read Port_bimu(i)                     'Port-Bitmuster holen
Next I

'Config Timer0 = Timer , Prescale = 256       'Timer mit Vorteiler 1:256
'Start Timer0                       'starten
Tccr0b = 4                              'Timer0 mit Vorteiler 1:256 starten
Timsk0 = Bits(ocie0a)                   'Compare0A-Interrupt freischalten
Enable Interrupts                       'Interrupts global freigeben
I = 1

Do                                      'Hauptschleife
  If R = 0 Then                         'vorwrts
    Decr Leuchtzeit(i)                  'Dimmwert runter
    If Leuchtzeit(i) >= Schritte Then Leuchtzeit(i) = 0       'und begrenzen
    Incr I                              'LED-Zhler erhhen
    If I > 8 Then I = 1                 'und auf 1-8 begrenzen
    Incr Leuchtzeit(i)                  'Dimmwert hoch
    If Leuchtzeit(i) < Schritte Then    '
      Decr I                            '
      If I = 0 Then I = 8
    End If
  Else
    Decr Leuchtzeit(i)                  'Dimmwert runter
    If Leuchtzeit(i) >= Schritte Then Leuchtzeit(i) = 0       'und begrenzen
    Decr I                              'LED-Zhler erhhen
    If I = 0 Then I = 8                 'und auf 1-8 begrenzen
    Incr Leuchtzeit(i)                  'Dimmwert hoch
    If Leuchtzeit(i) < Schritte Then    '
      Incr I                            '
      If I > 8 Then I = 1
    End If
  End If
  Waitus Tempo                          'Dauer bis zur nchsten nderung
Loop                                    'Ende Hauptschleife


Isr_oc0a:                               'ISR Timer Compare 0 A
  Do
    Incr N                              'LED-Zhler erhhen
    If N > 8 Then N = 1                 'und auf 1-8 begrenzen
  Loop Until Leuchtzeit(n) > 0
  Ocr0a = Ocr0a + Leuchtzeit(n)         'Zeitpunkt fr nchsten Interrupt festlegen
  Ddrb = Ddr_bimu(n)                    'Datenrichtung setzen
  Portb = Port_bimu(n)                  'Pegel Setzen
Return                                  'Ende ISR


Bitmuster:                              'Datenrichtung,Port
Data &B00010001 , &B00000001            'LED 1
Data &B00010001 , &B00010000            'LED 2
Data &B00010010 , &B00000010            'LED 3
Data &B00010010 , &B00010000            'LED 4
Data &B00010100 , &B00000100            'LED 5
Data &B00010100 , &B00010000            'LED 6
Data &B00011000 , &B00001000            'LED 7
Data &B00011000 , &B00010000            'LED 8