'Rundumleuchte mit 6 LEDs und Tiny13

'Pinbelegung ATTiny13:

'            Reset   Pin 1   Pin 8   Vcc
'             Poti   Pin 2   Pin 7   LED 5, LED 6
'   LED-Common (R)   Pin 3   Pin 6   LED 3, LED 4
'              GND   Pin 4   Pin 5   LED 1, LED 2




Const Schritte = 32                'Anzahl der Dimm-Schritte
Const Warze = 200                  'Wartezeit pro Einheit (in Mikrosekunden)
Const Maxtempo = 3                 'maximales Drehtempo

'Bascom-spezifische Deklarationen:
$regfile = "attiny13.dat"          'Portnamen vereinbaren
$crystal = 9600000                 'Takt vereinbaren
$hwstack = 32                      'Rcksprungadressen und Registersicherung
$swstack = 2                       'Parameterbergabe
$framesize = 2                     'Arbeitsbereich fr Funktionen

Dim Leuchtzeit(6)as Byte           'Leuchtdauer jeder LED
Dim Ddr_bimu(6)as Byte             'Bitmuster fr Datenrichtungsregister
Dim Port_bimu(6)as Byte            'Bitmuster fr Portregister
Dim I As Byte                      'Index auf LED im Hauptprogramm
Dim N As Byte                      'Index auf LED in ISR
Dim R As Byte                      'Richtung
Dim T As Byte                      'temporrer Schleifenzhler
Dim Tempo As Byte                  'ADC-Wert fr Drehtempo




On Oc0a Isr_oc0a

Clkpr = Bits(clkpce)               'Schreibschutz fr Taktvorteiler aufheben
Clkpr = 0                          'System-Taktvorteiler 1 zu 1
Clkpr = 0                          'sollte zweimal geschrieben werden

Restore Bitmuster                  'Zeiger auf Datenbereich im Flash
For I = 1 To 6                     'Bitmuster fr 6 LEDs
  Read Ddr_bimu(i)                 'Datenrichtungs-Bitmuster holen
  Read Port_bimu(i)                'Port-Bitmuster holen
Next I

Tccr0b = 4                         'Timer0 mit Vorteiler 1:256 starten
Timsk0 = Bits(ocie0a)              'Compare0A-Interrupt freischalten
sei                                'Interrupts global freigeben

Admux = Bits(adlar) + 3            'ADC3 linksbndig, freerun, Vorteiler
Adcsra = Bits(aden , Adsc , Adate , Adps2 , Adps1)       '1:64 (150kHz)



I = 1

Do                                 'Hauptschleife
  Tempo = Adch                     'ADC 8-bittig auslesen
  If Tempo > 127 Then
    R = 1                          'vorwrts (+1)
    Tempo = 0 - Tempo              'ja, nur obere Hlfte beachten
  Else
    R = 255                        'rckwrts (-1)
  End If
  Tempo = Tempo + Maxtempo         'Offset fr schnellstes Drehen

  Leuchtzeit(i) = Leuchtzeit(i) + 2       'aktive LED hochdimmen
  If Leuchtzeit(i) > Schritte Then I = I + R       'nchste LED
  If I > 250 Then I = 6            'Ring bei Unterlauf
  If I > 6 Then I = 1              'berlauf begrenzen
  For T = 1 To 6                   'alle LEDs
    If Leuchtzeit(t) > 0 Then Decr Leuchtzeit(t)       'herunterdimmen
  Next T                           'nchste LED-Leuchtzeit

  For T = 0 To Tempo               'Anzahl der Wartezeiten
    Waitus Warze                   'bis zur nchsten nderung
  Next T
Loop                               'Ende Hauptschleife


Isr_oc0a:                          'ISR Timer Compare 0 A
  Do
    Incr N                         'LED-Zhler erhhen
    If N > 6 Then N = 1            'und auf 1-6 begrenzen
  Loop Until Leuchtzeit(n) > 0
  Ocr0a = Ocr0a + Leuchtzeit(n)    'Zeitpunkt fr nchsten Interrupt festlegen
  Ddrb = Ddr_bimu(n)               'Datenrichtung setzen
  Portb = Port_bimu(n)             'Pegel Setzen
Return                             'Ende ISR


Bitmuster:                         'Datenrichtung,Port
Data &B00010001 , &B00000001       'LED 1
Data &B00010001 , &B00010000       'LED 2
Data &B00010010 , &B00000010       'LED 3
Data &B00010010 , &B00010000       'LED 4
Data &B00010100 , &B00000100       'LED 5
Data &B00010100 , &B00010000       'LED 6