'***************************** Seilbahn-Ansteuerung Version 1
'***************************** Paul Baumann / Hannes Lux 02/09

'Pinbelegung:
'PortB0 Taster Rosum  +LED 1
'PortB1 Taster Sorum  +LED 2
'PortB2 Poti
'PortB3 Oberer OPV
'PortB4 Unterer OPV

Const Fahrzeit = 20                                         'Fahrzeit in Sekunden
Const Wartezeit = 5                                         'Wartezeit in Sekunden

$regfile = "attiny13.dat"                                   'Portnamen vereinbaren
$crystal = 9600000                                          'Takt vereinbaren
$hwstack = 32                                               'mach'mer immer so
$swstack = 10                                               'mach'mer immer so
$framesize = 40                                             'mach'mer immer so und keiner wei warum

Ddrb = &B00011000                                           'Portb 4 und 3 Ausgang Rest Eingang
Portb = &B00000011                                          'Pullup an PB0-PB1 einschalten
Dim Geschwindigkeit As Byte                                 'Maximale Fahrgeschwindigkeit (ADC-Wert)
Dim Tempo As Byte                                           'aktuelle Geschwindigkeit (PWM-Tastgrad)
Dim Zeitzaehler As Byte                                     'Zhler fr Fahrzeit
Dim Pwmzaehler As Byte                                      'PWM (Software-Timer)
Dim Richtung As Byte                                        'vordefinierte Fahrtrichtung
Dim Motoraus As Byte                                        'vordefinieres Bitmuster zum Motor ausschalten
Dim Blinker As Byte                                         'Zeitvorteiler auf 1s und Zhler fr Blinkdauer
Dim Neumerker As Byte                                       'was nach dem Bremsen gemacht werden soll
Dim Neurichtung As Byte                                     'was nach dem Bremsen gemacht werden soll
Dim Warten As Byte                                          'Zhler fr Wartezeit
Dim Tastalt As Byte                                         'alter Tastenzustand
Dim Tastneu As Byte                                         'neuer Tastenzustand
Dim Merker As Byte                                          'Status der Steuerung
'Merker.0   Status, Taster an PB0 (Rosum) wurde gedrckt
'Merker.1   Status, Taster an PB1 (Sorum) wurde gedrckt
'Merker.2   Status, Endlage Rosum wurde erreicht
'Merker.3   Status, Endlage Sorum wurde erreicht
'Merker.7   Job, PWM ist einmal rum

Clkpr = 128                                                 'Systemtakt-Schreibschutz aufheben
Clkpr = 0                                                   'Systemtakt auf 9,6 MHz umschalten

Config Timer0 = Timer , Prescale = 1                        'Timer erzeugt alle 27ms einen Interrupt
Enable Timer0                                               'Timer-Interrupt freigeben

Admux = &B00100001                                          'ADC-Kanal 1, Vcc als Referenz, Linksbndig
Adcsra = &B11100010                                         'mit 150 Khz

On Timer0 Ontimer0                                          'Vektor zur Timer0-ISR
Enable Interrupts                                           'Interrupts global freigeben
Tastalt = 0                                                 'unbettigte Tasten merken

'************************************ Hauptschleife ;-)
Do
   If Merker.7 = 1 Then                                     'vor jedem berlauf des PWM-Zhlers
      Merker.7 = 0                                          'Job entwerten
'Anfahren und Bremsen
      If Merker.6 = 1 Then                                  'ist Bremsmodus aktiv?
         If Tempo > 0 Then                                  'ja, fhrt er noch?
            Decr Tempo                                      'ja, Fahrt verringern
         Else                                               'nein,
            If Warten = 0 Then
               Merker = Neumerker                           'neuen Status
               Richtung = Neurichtung                       'bernehmen
               If Merker.0 = 1 Then Zeitzaehler = Fahrzeit  'Zeit starten, falle
               If Merker.1 = 1 Then Zeitzaehler = Fahrzeit  'eine Fahrt angemeldet ist
            End If
         End If
      Else
         If Tempo < Geschwindigkeit Then Incr Tempo         'Tempo anpassen
      End If
'Tasten prfen
      Ddrb = &B00011000                                     'Taster als Eingang
      Portb = &B00000011                                    'LEDs aus, PullUps ein, Motor ist sowiso aus
      Geschwindigkeit = Adch                                'ADC nebenher einlesen
      Tastneu = Not Pinb                                    'Tasten einlesen
      Tastneu = Tastneu Xor Tastalt                         'nur nderungen bernehmen
      Tastalt = Tastalt Xor Tastneu                         'neuen Zustand merken
      Tastneu = Tastneu And Tastalt                         'nur gedrckte Tasten akzeptieren
      If Tastneu.0 = 1 Then                                 'ist Taste 0 gedrckt?
         Merker.6 = 1                                       'Bremse auslsen
         Neumerker = &B00000001                             'ja, vorwrts fahren
         Neurichtung = &B00001011                           '
         If Zeitzaehler > 0 Then
            Warten = Wartezeit                              'Wartezeit vorbereiten
            Zeitzaehler = 0
         End If
      End If
      If Tastneu.1 = 1 Then                                 'ist Taste 1 gedrckt?
         Merker.6 = 1                                       'Bremse auslsen
         Neumerker = &B00000010                             'ja, rckwrts fahren
         Neurichtung = &B00010011                           '
         If Zeitzaehler > 0 Then
            Warten = Wartezeit                              'Wartezeit vorbereiten
            Zeitzaehler = 0
         End If
      End If
      Ddrb = &B00011011                                     'Taster als LED-Ausgang
'Fahrzeit prfen
      Decr Blinker                                          'Blinkzhler (Zeitvorteiler) runter
      If Blinker = 0 Then                                   'eine Sekunde um?
         Blinker = 146                                      'ja, auf Startwert
         If Zeitzaehler = 0 Then                            'wenn Fahrzeit aktiv, dann
            If Warten <> 0 Then Decr Warten                 'Wartezeit runter, falls aktiv
         Else
            Decr Zeitzaehler                                'akt. Fahrzeit runter
            If Zeitzaehler = 0 Then                         'ist Fahrzeit abgelaufen?
               Neumerker = Merker                           'Brems-Status
               Shift Neumerker , Left , 2                   'vorbereiten
               Neumerker = Neumerker And &B00001100
               Neurichtung = &B00000011                     'Motor nach Bremsen aus
               Merker.6 = 1                                 'Bremsen einschalten
               Warten = Wartezeit                           'Wartezeit vorbereiten
            End If
         End If
      End If
'Blinken
      If Blinker > 73 Then                                  'Blinkphase?
         If Warten = 0 Then                                 'wenn gefahren wird
            Richtung.0 = Not Richtung.3                     'Vorwrts-LED-Bit wie Vorwrts-Motorbit in PWM-Ein-Phase
            Motoraus.0 = Not Richtung.3                     'Vorwrts-LED-Bit wie Vorwrts-Motorbit in PWM-AUS-Phase
            Richtung.1 = Not Richtung.4                     'Rckwrts-LED-Bit wie Rckwrts-Motorbit in PWM-Ein-Phase
            Motoraus.1 = Not Richtung.4                     'Rckwrts-LED-Bit wie Rckwrts-Motorbit in PWM-AUS-Phase
         Else
            Richtung = Richtung And &B00011000              'beide LEDs
            Motoraus = Motoraus And &B00011000              'blinken lassen
         End If
      Else                                                  'nein,
         Richtung = Richtung Or 3                           'LEDs in PWM-Ein-Phase aus
         Motoraus = 3                                       'LEDs in PWM-Aus-Phase aus
      End If
'Endlage erreicht?
      If Merker.2 = 1 Then
         Richtung = &B00000010                              'Motor aus und
         Motoraus = &B00000010                              'LED 0 ein
      End If
      If Merker.3 = 1 Then
         Richtung = &B00000001                              'Motor aus und
         Motoraus = &B00000001                              'LED 1 ein
      End If
   End If
Loop

'************************************ Timerinterrupt-Service-Routine
Ontimer0:
   Incr Pwmzaehler                                          'PWM-Zhler hoch
   If Pwmzaehler = 255 Then
      Merker.7 = 1                                          'einmal je Runde Mainloop anschubsen
   End If
   If Pwmzaehler < Tempo Then                               'PWM in der Ein-Phase?
      Portb = Richtung                                      'ja, Motor einschalten
   Else
      Portb = Motoraus                                      'nein, Motor ausschalten
   End If
Return                                                      'fertig, zurck...
