'Tuuut, das Tattata-Programm

'Es handelt sich hier um einen Signalgeber, der wechselweise zwei verschiedene
'Frequenzen an Pin 5 erzeugt, solange der Jumper an Pin 6 geschlossen ist.


'Anschlussbelegung des Tiny13:

'Pin 1: Reset, Widerstand 4k7...10k nach Pin 8 (VCC)
'Pin 2: PB3, unbenutzt
'Pin 3: PB4, unbenutzt
'Pin 4: GND, Masse
'Pin 5: PB0, OC0A, Soundausgang, Lautsprecher ber kleinen Elko an GND
'Pin 6: PB1, Jumper fr Soundfreigabe gegen GND
'Pin 7: PB2, unbenutzt
'Pin 8: VCC, Versorgungsspannung, Kerko 100n nach GND, Reset-Widerstand

'Das Programm wurde bewusst ohne Interrupts geschrieben, da in Bascom die
'Interrupts aufgrund der kompletten Registersicherung unntig lange dauern.

'Die Fusebits des Tiny13 sind folgendermaen einzustellen:
'High-Fuse: 0xFB, Low-Fuse: 0x6A
'Dabei ist eigentlich nur Brown-Out auf 2,7 Volt eingestellt. Alle anderen
'Fuses sind im Auslieferungszustand des Tiny13 belassen worden. Die
'Takteinstellung erfolgt nicht per Fusebits, sondern per Software.
'Dazu muss der interne RC-Oszillator mit 9,6 MHz aktiviert sein. Der Zustand
'der CKDIV8-Fuse ist egal, der Clock-Prescaler wird per Software berschrieben.


'einige vordefinierte Parameter:
'nderungen erlaubt:
'Zeitdauer des Tons, siehe Hilfe zu Waitms
Const Dauer1 = 500                'Zeitdauer fr Ton 1 in ms
Const Dauer2 = 500                 'Zeitdauer fr Ton 2 in ms
'Zhlumfang des Timers (CTC-Mode) zur Erzeugung der Tonfrequenz,
'200 ergibt 3 kHz, denn der Timer zhlt im Raster von 1/1200 ms (1200 kHz)
Const Freq1 = 230                  'Timerwert fr Frequenz Ton 1
Const Freq2 = 170                  'Timerwert fr Frequenz Ton 2

'Bitte nicht ndern:
Const Frei = &B01000010            'Bitmuster zum Freigeben des OC0A-Pins
'COM0A0 und WGM01 in TCCR0A gesetzt, Toggeln von OC0A bei Compare-Match
'siehe Datenblatt Seite 68 bis 70


'Bascom-spezifische Deklarationen:
$regfile = "attiny13.dat"          'Portnamen vereinbaren
$crystal = 1200000                 'Takt fr Warteschleifen vereinbaren
$hwstack = 32                      'Rcksprungadressen
$swstack = 8                       'Parameterbergabe
$framesize = 16                    'Spielwiese fr Funktionen

'Den Portpins erstmal sinnvolle/sinnlose Namen geben:
Nf_out Alias Portb.0               'NF-Ausgang
Jumper Alias Pinb.1                'Eingang fr Jumper


'Programmstart, Reset-Routine:
'Tiny13 auf 1,2 MHz umschalten, siehe Datenblatt Seite 25 und 26:
Clkpr = 128                        'Taktvorteiler Schreibschutz aufheben
Clkpr = 3                          'Taktvorteiler auf 1:8
Clkpr = 3                          'einstellen

'PB1 (Pin 6) wird der Jumper-Eingang, alles andere werden Ausgnge
Portb = &B11110                    'NF auf L-Pegel, alle PullUps ein
Set Ddrb.0                         'NF_Out als Ausgang, Rest als Eingeng
'Alle TimeOut-Zhler auf 0 (definierte Startbedingungen)

'Timer einschalten, erstmal ohne Sonderfunktionen
Tccr0a = 0                         'Pin OC0A erstmal vom Timer trennen
Tccr0b = 1                         'Timer mit Vorteiler 1:1 starten

'Hauptschleife des Programms
Do                                 'Beginn der Endlos-Schleife
  If Jumper = 1 Then               'wenn Jumper offen ist (H-Pegel)
    Tccr0a = 0                     'Pin OC1A vom Timer trennen
  Else                             'Jumper ist geschlossen (L-Pegel)
    Ocr0a = Freq1                  'Frequenz 1 einstellen
    Tccr0a = Frei                  'Ausgang OC0A an Timer binden
    Waitms Dauer1                  'Ende des Tons abwarten
    Ocr0a = Freq2                  'Frequenz 2 einstellen
    Waitms Dauer2                  'Ende des Tons abwarten
  End If
Loop                               'Ende der Endlos-Schleife